//FFSubmenu=Exif
//FFName=History
//FFPath=History.js
/*	ab 2.76 B78
	V0.7a
	20.10.04 by Ralf-Peter Nerlich (Squirrel)
	Beste Ansicht mit Tabstops=4
*/

DEBUG = false;

// Konstanten
var FF_MIN_VERSION = 27678;
var FF_SCRIPT_VERSION = "0.7a (20.10.04)"
var CrLf		= "\r\n";
var SS_CENTER	= 0x000001;
var ES_READONLY	= 0x000800;
var WS_HSCROLL	= 0x100000;
var WS_VSCROLL	= 0x200000;
var ForReading=1, ForWriting=2, ForAppending=8;

// Teste FixFoto-Version
var v = (FF_GetMajor() * 10000) + (FF_GetMinor() * 100) + FF_GetBuild();

if (DEBUG) FF_MessageBox("Debug:"+CrLf+dbg(v), 64);

if (v < FF_MIN_VERSION)
{
	FF_ErrorBreak("Mindestens FixFoto Version 2.76 Build 78 erforderlich");
}

// Variable
var img, img1, hist, log, exi, tmp, arg, sqf, kor;
var common_log, dir_log, bild_log;
var fso = new ActiveXObject("Scripting.FileSystemObject");

// Fr Dialog
var dlg = "Bearbeitungsprotokollierung";
var but = "";

// Test auf Parameter/Speicherscript
// F10  => kein Parameter
// Save => QF filename
tmp = FF_GetParam();
if (tmp == "")												// Aufruf ber Dialog?
{
	sqf = "";
	img = FF_GetImageName(-1);
} else														// oder als Speicherscript
{
	arg = tmp.split(CrLf);
	sqf = arg[0];
	img = arg[1];
}

if (DEBUG) FF_MessageBox("Debug:"+CrLf+dbg(tmp)+dbg(sqf)+dbg(img), 64);

if (img == "")
{
	FF_MessageBox("Kein Bild geladen", 16);
} else
{
	FF_SetCurrentPath(fso.GetParentFolderName(img));
	tmp = FF_GetHistory();
	tmp == "" ? "" : tmp += CrLf;
	hist = SavedDate() + tmp + SavedQF(sqf, img) ;
	FF_AddDialog(dlg, 220, 130);
	FF_AddControl(dlg, "Bearbeitete Datei:", "STATIC", 6, 0, 100, 10);
	FF_AddControl(dlg, "DL_Path", "EDIT", 5, 10, 150, 10);
	FF_SetControlStyle(dlg, "DL_Path", ES_READONLY);
	FF_AddControl(dlg, "Change", "BUTTON", 160, 10, 25, 10);
	FF_AddControl(dlg, "Info", "BUTTON", 190, 10, 25, 10);
	FF_AddControl(dlg, "Bearbeitungsschritte:", "STATIC", 6, 20, 100, 10);
	FF_AddControl(dlg, "DL_Text", "EDIT", 5, 30, 210, 80);
	FF_SetControlStyle(dlg, "DL_Text", WS_VSCROLL + WS_HSCROLL);
	FF_AddControl(dlg, "Korrektur", "STATIC", 5, 115, 25, 10);
	FF_AddControl(dlg, "HKorr", "BOOL", 30, 115, 10, 10);
	FF_AddControl(dlg, "Zentral", "BUTTON", 45, 115, 30, 10);
	FF_AddControl(dlg, "Verz.", "BUTTON", 80, 115, 30, 10);
	FF_AddControl(dlg, "Bild", "BUTTON", 115, 115, 30, 10);
	FF_AddControl(dlg, "EXIF", "BUTTON", 150, 115, 30, 10);
	FF_AddControl(dlg, "Abbruch", "BUTTON", 185, 115, 30, 10);
	if (! isJPG(img) || ! FF_HasExif())
	{
		FF_EnableControl(dlg, "EXIF", false);
	}
	FF_SetControl(dlg, "DL_Path", img);
	FF_SetControl(dlg, "DL_Text", hist);
	FF_SetControl(dlg, "HKorr", 0);
	FF_ActivateControl(dlg, "Verz.");
	do
	{
		if ( but != "Abbruch" && but != "CANCEL")
		{ 
			img1 = img;
			but = FF_ShowDialog(dlg);
			switch (but)
			{
				case "Change":
					but = "";
					// bei mehrfach Change immer vom Ur-Verzeichnis aus
					//FF_SetCurrentPath(fso.GetParentFolderName(img));
					img = FF_EnterFileName(true, fso.GetFileName(img));
					img == "" ? img = img1 : FF_SetControl(dlg, "DL_Path", img);
					break;
				case "Info":
					but = "";
					FF_MessageBox(About(), 64);
					break;
			}
			img = FF_GetControl(dlg, "DL_Path");

			if (! fso.FileExists(img))
			{
				but = "";
				FF_MessageBox("\"Bearbeitete Datei\" existiert nicht!", 48);
				img = img1;
			}
			if (! isGrafik(img))
			{
				but = "";
				FF_MessageBox("\"Bearbeitete Datei\" ist keine Grafikdatei!", 48);
				img = img1;
			}

			FF_SetControl(dlg, "DL_Path", img);
			FF_EnableControl(dlg, "EXIF", (isJPG(img) && FF_LoadExif(img) && FF_HasExif()));
		}
	} while (but == "")

	hist = FF_Getcontrol(dlg, "DL_Text");
	kor  = FF_GetControl(dlg, "HKorr");
	FF_CloseDialog(dlg);

	dir_log  = fso.GetParentFolderName(img) + "\\history.log";
	bild_log = fso.GetParentFolderName(img) + "\\" + fso.GetBaseName(img) + ".log";
	common_log = FF_GetFFPath() + "\\history.log";

	switch(but)
	{
		case "Zentral":
			log = fso.OpenTextFile(common_log, ForAppending, true);
			log.WriteLine(img);
			log.WriteLine(hist);
			log.WriteBlankLines(1);
			log.Close();
			if (kor == 1) RunEdit(common_log);
			break;
		case "Verz.":
			log = fso.OpenTextFile(dir_log, ForAppending, true);
			log.WriteLine(img);
			log.WriteLine(hist);
			log.WriteBlankLines(1);
			log.Close();
			if (kor == 1) RunEdit(dir_log);
			break;
		case "Bild":
			log = fso.OpenTextFile(bild_log, ForAppending, true);
			log.WriteLine(hist);
			log.WriteBlankLines(1);
			log.Close();
			if (kor == 1) RunEdit(bild_log);
			break;
		case "EXIF":
			exi = FF_GetExifTag("UserComment")
			if (exi != "") exi += CrLf;						//Wenn nicht leer
			if (DEBUG) FF_MessageBox(exi + hist, 0);
			FF_SetExifTag("UserComment", exi + hist);
			FF_SetExifTag("Software", GetFixFotoInfo());
			FF_SaveExif(img);
			FF_Reload();
			//FF_LoadExif(img);
			break; 
	}
}

function GetFixFotoInfo()
{
	var s = "FixFoto Version ";
	s += FF_GetMajor() + ".";
	s += FF_GetMinor() + ".";
	s += FF_GetBuild();
	return(s);
}

function GetScriptEngineInfo()
{
	var s = "";
	s += ScriptEngine() + " Version ";
	s += ScriptEngineMajorVersion() + ".";
	s += ScriptEngineMinorVersion() + ".";
	s += ScriptEngineBuildVersion();
	return(s);
}

function About()
{
	return (GetScriptEngineInfo() + CrLf +
			GetFixFotoInfo() + CrLf +
			"Script Version " + FF_SCRIPT_VERSION + CrLf +
			"(c)2004 Ralf-Peter Nerlich");
}
function SavedDate()
{
	var s = "Bearbeitet: ";
	var d = new Date();										//System-Datum
	s += d.getDate() + ".";
	s += (d.getMonth() + 1) + ".";
	s += d.getFullYear() + " ";
	s += NumToString(d.getHours()) + ":";
	s += NumToString(d.getMinutes()) + ":";
	s += NumToString(d.getSeconds());
	return (s + CrLf);
}

function NumToString(n)
{
	var s = n < 10 ? "0" : "";
	return (s += n.toString(10));
}

function SavedQF(s, f)
{
	var q = "";
	if (s != "")
	{
		switch(fso.GetExtensionName(f).toUpperCase())
		{
			case "JPG":
			case "JPEG":
			case "JPE":
			case "JP2":
				q = "QF " + (parseInt(s, 10) / 100).toFixed(2) + CrLf;
				break;
			case "TIF":
			case "TIFF":
				q = s > 1 ? "" : "LZW " + s + CrLf;
				break;
		}
	}
	return (q)
}

function isJPG(f)
{
	var ext = new RegExp("_" + fso.GetExtensionName(f) + "_", "i");
	return (ext.test("_JPG_JPEG_JPE_"));
}

function isGrafik(f)
{
	var ext = new RegExp("_" + fso.GetExtensionName(f) + "_", "i");
	return (ext.test("_JPG_JPEG_JPE_JP2_TIF_TIFF_PNG_BMP_"));
}

function RunEdit(f)
{
	if (fso.FileExists(f))
	{
		var shell = new ActiveXObject("WScript.Shell");
		shell.Run("notepad.exe " + f, 1, true);
	}
}

function dbg(s)
{
	return ("<" + s + ">" + CrLf);
}
